#include <stdio.h>

/****************************************************************************/

  /* QuickSort algoritam.
     Varijanta iz Wirth (A+DS=P, str. 79).
     Srednji element je kljucni element.
     Bez funkcije swap, zamjene su izravno u kodu.
  */

/****************************************************************************/

  /* Sortiranje QuickSort algoritmom.
     Srednji element x[(l + d)/2] je kljucni element
     i dovodimo ga na pravo mjesto u polju.
     Zamjene u kodu (bez swap). */

    /* Rekurzivna funkcija za quick_sort.
       Ocekuje bar 1 element, tj. l <= d.
       Provjera toga mora biti PRIJE poziva. */

void quick_sort(int x[], int l, int d)
{
    int i, j, x_s, temp;

        /* Ocekuje l <= d. Provjera mora prije poziva.
           Kljucni element je srednji u zadanom komadu polja. */
    x_s = x[ (l + d) >> 1 ];    /* x[ (l + d) / 2 ]. */
    i = l;
    j = d;

        /* Prolaz mora i za i == j */
    do {
        while (x[i] < x_s) ++i;
        while (x[j] > x_s) --j;
        if (i <= j) {
                /* Zamjena ne treba za i == j */
            if (i < j) {
                temp = x[i];
                x[i] = x[j];
                x[j] = temp;
            }
            ++i;
            --j;
        }
    } while (i <= j);

        /* Provjera duljine prije rekurzivnih poziva. */
    if (l < j) quick_sort(x, l, j);
    if (i < d) quick_sort(x, i, d);

    return;
}

/* ======================================================================== */

    /* Glavna funkcija za sortiranje, koja se zove izvana. */

void q_sort(int x[], int n)
{
    if (n >= 1)
        quick_sort(x, 0, n - 1);

    return;
}

/****************************************************************************/

int main(void)
{
    int i, n;
    int x[] = {42, 12, 55, 94, 18, 44, 67};

    n = 7;
    q_sort(x, n);

    printf("\n Sortirano polje x:\n");
    for (i = 0; i < n; ++i) {
        printf(" x[%d] = %d\n", i, x[i]);
    }

    return 0;
}
