#include <stdio.h>

/****************************************************************************/

  /* Sortiranje QuickSort algoritmom.
     Prvi element x[l] je kljucni element
     i dovodimo ga na pravo mjesto u polju.
       Ima provjeru za bar 2 elementa PRIJE
     rekurzivnih poziva i u glavnoj funkciji. */

  /* Ispisuje sve bitne stvari u algoritmu. */

void swap(int *a, int *b)
{
    int temp;

    temp = *a;
    *a = *b;
    *b = temp;

    return;
}

/* ======================================================================== */

    /* Rekurzivna funkcija za quick_sort.
       Ocekuje bar 2 elementa, tj. l < d.
       Provjera toga mora biti PRIJE poziva. */

void quick_sort(int x[], int l, int d)
{
    int i, j;

    printf("\n QuickSort(%d, %d):\n", l, d);

        /* Ocekuje l < d. Provjera mora prije poziva. */
    i = l + 1;
    j = d;
    printf("    start:  i = %d, j = %d\n", i, j);

        /* Prolaz mora i za i == j */
    while (i <= j) {
        printf("      while, vrh:  i = %d, j = %d\n", i, j);

        while (i <= d && x[i] <= x[l]) ++i;
        while (x[j] > x[l]) --j;

        printf("      while, dno:  i = %d, j = %d\n", i, j);

        if (i < j) {
            swap(&x[i], &x[j]);
            printf("         zamjena:  x[%d] <-> x[%d]\n", i, j);
            printf("         sada je:  x[%d] = %d,  x[%d] = %d\n",
                    i, x[i], j, x[j]);
        }
    }

    printf("     kraj:  l = %d, j = %d\n", l, j);

    if (l < j) {
        swap(&x[j], &x[l]);
        printf("         zamjena:  x[%d] <-> x[%d]\n", l, j);
        printf("         sada je:  x[%d] = %d,  x[%d] = %d\n",
                l, x[l], j, x[j]);
    }

    printf("   lijevi podniz:  ");
    if (l <= j - 1)
        printf("x[%d .. %d]\n", l, j - 1);
    else
        printf("prazan\n");

    printf("    desni podniz:  ");
    if (j + 1 <= d)
        printf("x[%d .. %d]\n", j + 1, d);
    else
        printf("prazan\n");

    if (l < j - 1) quick_sort(x, l, j - 1);
    if (j + 1 < d) quick_sort(x, j + 1, d);

    return;
}

/****************************************************************************/

int main(void)
{
    int i, n;
    int x[] = {42, 12, 55, 94, 18, 44, 67};

    n = 7;

    printf("\n Nesortirano polje x:\n");
    for (i = 0; i < n; ++i) {
        printf(" x[%d] = %d\n", i, x[i]);
    }

    if (n >= 2) quick_sort(x, 0, n - 1);

    printf("\n Sortirano polje x:\n");
    for (i = 0; i < n; ++i) {
        printf(" x[%d] = %d\n", i, x[i]);
    }

    return 0;
}
