#include <stdio.h>

  /* Hanojski tornjevi s n diskova.
     Ispisuje redosljed poteza, tj.
     prebacivanja (najgornjih) diskova. */

void prebaci_jednog(int odakle, int kamo)
{
    printf("  prebaci s %d na %d\n", odakle, kamo);

    return;
}

    /* Funkcija ima sva tri stapa u argumentima, ukljucivo i pomocni.
       Nema nepotrebne pozive za n = 0 (koji nista ne rade).
       Prvo testira prekid rekurzije, a rekurzija je u else. */

void Hanojski_tornjevi(int n, int odakle, int kamo, int pomocni)
{
    if (n <= 1)    // Uz n > 0, to znaci n == 1.
        prebaci_jednog(odakle, kamo);
    else {
        Hanojski_tornjevi(n - 1, odakle, pomocni, kamo);
        prebaci_jednog(odakle, kamo);
        Hanojski_tornjevi(n - 1, pomocni, kamo, odakle);
    }

    return;
}

int main(void)
{
    int n;

    for (n = 1; n <= 5; ++n) {
        printf("\n Prebaci %d diskova s 1 na 3:\n", n);
        Hanojski_tornjevi(n, 1, 3, 2);
    }

    return 0;
}
