#include <stdio.h>

  /* Particije - Varijacija 1:
       Broj rastava zadanog prirodnog broja n u sumu
     strogo rastucih (prirodnih) pribrojnika.
     Dozvoljen je i samo jedan pribrojnik.

     Rekurzivno generira (broji i zbraja) sve particije.
     Osnovni rekurzivni algoritam (poput parts_1.c, par_0.c).

     Umjesto citanja broja n,
     ispisuje broj opisanih particija p_1(n),
     za sve brojeve n = 1, ..., 100.
     Ispisuje i broj rekurzivnih poziva funkcije.
  */

    /* Globalni brojac rekuzivnih poziva funkcije. */

unsigned int broj_poziva;


    /* Nadji sve opisane particije broja suma u kojima je
       prvi (sljedeci) pribrojnik barem jednak broju prvi. */

int particije_1(int suma, int prvi)
{
    int i, broj = 0;

        /* Povecaj globalni brojac poziva funkcije. */
    ++broj_poziva;

        /* Provjera kraja rekurzije i jesmo li nasli rastav. */
    if (suma == 0) return 1;

        /* Rekurzivni pozivi - dodavanje sljedeceg pribrojnika i,
           uz ogranicenje prvi <= i <= suma:
           - preostala suma je suma - i,
           - sljedeci prvi je barem i + 1. */

    for (i = prvi; i <= suma; ++i)
        broj += particije_1(suma - i, i + 1);

    return broj;
}

    /* Nerekurzivna funkcija za racunanje p_1(n).
       Zove rekurzivnu funkciju particije_1,
       s dodatnim argumentom prvi = 1. */

int p_1(int n)
{
        /* Poziv rekurzivne funkcije particije_1, s prvi = 1. */
    return particije_1(n, 1);
}

int main(void)
{
    int n;

        /* Zaglavlje tablice. */
    printf("\n");
    printf("      Broj particija       Broj poziva\n");
    printf(" ---------------------------------------\n");

    for (n = 1; n <= 100; ++n ) {

            /* Inicijalizacija globalnog brojaca poziva. */
        broj_poziva = 0u;

            /* Redak tablice. */
        printf("   p_1(%3d) = %10d    %10u\n",
               n, p_1(n), broj_poziva);
    }

    return 0;
}
