#include <stdio.h>

  /* Particije - Varijacija 3:
       Broj rastava zadanog prirodnog broja n u sumu
     od tocno k nepadajucih (prirodnih) pribrojnika,
     gdje je k zadani prirodan broj.

     Rekurzivno generira (broji i zbraja) sve particije.
     Osnovni rekurzivni algoritam (poput parts_1.c, par_0.c).

     Ucitava (prirodne) brojeve n i k,
     ispisuje broj opisanih particija p_3(n, k).
     Ispisuje i broj rekurzivnih poziva funkcije.
  */

    /* Globalni brojac rekuzivnih poziva funkcije. */

unsigned int broj_poziva;


    /* Nadji sve opisane particije broja suma u kojima je
       prvi (sljedeci) pribrojnik barem jednak broju prvi. */

int particije_3(int suma, int k, int prvi)
{
    int i, broj = 0;

        /* Povecaj globalni brojac poziva funkcije. */
    ++broj_poziva;

        /* Provjera kraja rekurzije i jesmo li nasli rastav. */
    if (k == 0) {
            /* Svi pribrojnici su vec postavljeni => kraj. */
        if (suma == 0)
           return 1;
        else
           return 0;
    }

        /* Rekurzivni pozivi - dodavanje sljedeceg pribrojnika i,
           uz ogranicenje prvi <= i <= suma:
           - preostala suma je suma - i,
           - broj pribrojnika u preostaloj sumi je jednak k - 1,
           - sljedeci prvi je barem i. */

    for (i = prvi; i <= suma; ++i)
        broj += particije_3(suma - i, k - 1, i);

    return broj;
}

    /* Nerekurzivna funkcija za racunanje p_3(n, k).
       Zove rekurzivnu funkciju particije_3,
       s dodatnim argumentom prvi = 1. */

int p_3(int n, int k)
{
        /* Poziv rekurzivne funkcije particije_3, s prvi = 1. */
    return particije_3(n, k, 1);
}

int main(void)
{
    int n, k;

    printf(" Upisi prirodne brojeve n i k: ");
    scanf("%d%d", &n, &k);

    broj_poziva = 0u;

    printf("\n\n");
    printf(" Broj particija p_3(%d, %d) = %d\n",
           n, k, p_3(n, k));
    printf(" Broj poziva funkcije = %u\n",
           broj_poziva);

    return 0;
}
