#include <stdio.h>

  /* Ucitava n i pise broj particija broja n,
     tj. broj rastava broja n u sumu nepadajucih
     prirodnih brojeva.
     Rekurzivno broji i zbraja sve generirane particije.

     Prva ideja za efikasniji zavrsetak rekurzije,
     tj. izbjegavanje nepotrebnih poziva.
     KOREKTNA realizacija, uz malu modifikaciju uvjeta.
     Radi dobro, ali jos uvijek ima nepotrebnih poziva.
  */

    /* Globalni brojac rekuzivnih poziva funkcije. */

unsigned int broj_poziva;

    /* Nadji sve particije broja suma u kojima je prvi (sljedeci)
       pribrojnik barem jednak prvi. */

int particije(int suma, int prvi)
{
    int i, broj = 0;

        /* Povecaj globalni brojac poziva funkcije. */
    ++broj_poziva;

        /* Modifikacija realizacije ideje za ubrzanje iz par_2.c:

           Uocimo da se petlja po i NE izvrsava ako je suma < prvi
           (cak i za suma = prvi, zbog  i < suma).
           Kad vec testiramo je li suma >= prvi, onda i tu petlju
           stvaljamo u pripadni blok. To izbjegava dvostruko
           testiranje kad je prvi > suma. */

    if (suma >= prvi) {

            /* Za i = suma, povecaj broj za 1. */
        ++broj;

            /* Rekurzivni pozivi - dodavanje sljedeceg pribrojnika i,
               za prvi <= i < suma (bez i = suma). */
        for (i = prvi; i < suma; ++i)
            broj += particije(suma - i, i);
    }
    return broj;
}

int main(void)
{
    int n;

    printf(" Upisi prirodni broj n: ");
    scanf("%d", &n);

    broj_poziva = 0u;

    printf("\n Broj particija p(%d) = %d\n",
           n, particije(n, 1) );

    printf("\n Broj poziva funkcije = %u\n",
           broj_poziva);

    return 0;
}
