#include <stdio.h>
#include <string.h>

  /* Citanje ulaza po nacelu "jedan red = jedan string".

     Treba ucitati jedan red teksta s ulaza, ukljucivo i kraj reda
     (odnosno, prijelaz u novi red), tj. zadnji procitani znak mora
     biti \n (kraj reda). U zadani string treba spremiti samo znakove
     ISPRED kraja reda, BEZ kraja reda. Dakle, kraj reda treba UCITATI,
     ali NE i spremiti (kao u gets)!

     Pretpostavka: ulazni red STANE u string.
     NE pazi na "prepunjenje" stringa (broj spremljenih znakova). */

  /* Citanje reda funkcijom scanf (formatirano) - 1. varijanta:
       Za citanje (preskakanje) \n koristimo bas format "\n".
     Ovo NE radi dobro!
  */

int main(void)
{
        /* U polje s stane najvise 19 znakova sadrzaja stringa, tako da IZA
           sadrzaja ima jos jedno mjesto za nul-znak (\0) = kraj stringa. */
    char s[20];
        /* Duljina ucitanog stringa (strlen), bez nul-znaka. */
    unsigned int d;

    printf("Upisite string u jednom redu:\n");

        /* Citanje jednog reda ulaza u string.
           Cita se cijeli red ulaza, zajedno s (prvim) krajem reda \n.
           Provjerava je li nesto ucitano u string. Ako NIJE,
           postavlja s[0] = '\0', tj. s = "" (prazan string). */

        /* Maksimalna sirina polja = 19 = sizeof(s) - 1 NIJE nuzna. */

        /* Prvi scanf, s formatom "%19[^\n]", cita najvise 19 znakova
           razlicitih od kraja linije i sprema ih u polje s.
           Na kraju, dodaje nul-znak \0 IZA zadnjeg ucitanog znaka u s,
           tako da je s korektan string.
           Ako je ulaz korektan, tj. ulazni red ima NAJVISE 19 znakova
           (bez \n), onda prvi sljedeci znak na ulazu mora biti \n. */
    if (scanf("%19[^\n]", s) < 1) s[0] = '\0';

        /* Drugi scanf ima format "\n". Znak \n iz formata trebao bi se
           "spariti" sa znakom \n na ulazu.
           Medjutim, to NE radi onako kako ocekujemo!

           Razlog: \n u format-stringu se interpretira kao BJELINA, tj.
           isto kao da u formatu pise blank (praznina). Bjelina = bilo
           koji od 6 znakova koji se interpretiraju kao bjeline! Zato se
           \n (kao i blank) sparuje s VISE bjelina, a ne samo s jednom.
           PRVA od njih je upisani \n (ENTER). Na kraju stringa mozemo
           napisati nekoliko prijelaza u novi red (ENTER) ili blankova
           (ili bilo kojih bjelina) uzastopce, i SVI ti znakovi se
           "sparuju" s \n u format-stringu.

           Zato scanf ceka prvi znak koji NIJE bjelina, da "zna" koliki
           komad ulaza mora "preskociti". Tek kad upisemo PRVI znak koji
           NIJE bjelina (i jos ENTER iza toga), scanf PREKIDA citanje.
           Prvi neprocitani znak je onaj PRVI koji NIJE bjelina. */
    scanf("\n");

        /* Duljina stringa. */
    d = strlen(s);

        /* Ispis ucitanog stringa i duljine (strlen). */
    printf("\nUcitani string (pocinje u sljedecem redu):\n%s\n", s);
    printf("\nDuljina stringa = %u\n", d);


        /* Provjera: nastavak citanja po istom principu = citamo
           sljedeci red u string s. */

    printf("\nUpisite sljedeci string u jednom redu:\n");

    if (scanf("%19[^\n]", s) < 1) s[0] = '\0';
    scanf("\n");

        /* Duljina stringa. */
    d = strlen(s);

        /* Ispis sljedeceg ucitanog stringa i duljine (strlen). */
    printf("\nDrugi string (pocinje u sljedecem redu):\n%s\n", s);
    printf("\nDuljina stringa = %u\n", d);

    return 0;
}
