#include <stdio.h>
#include <string.h>

  /* Citanje ulaza po nacelu "jedan red = jedan string".

     Treba ucitati jedan red teksta s ulaza, ukljucivo i kraj reda
     (odnosno, prijelaz u novi red), tj. zadnji procitani znak mora
     biti \n (kraj reda). U zadani string treba spremiti samo znakove
     ISPRED kraja reda, BEZ kraja reda. Dakle, kraj reda treba UCITATI,
     ali NE i spremiti (kao u gets)!

     Ulazni red moze biti PREDUGACAK.
     PAZI na "prepunjenje" stringa (broj spremljenih znakova).

     U zadani string sprema se najvise onoliko znakova koliko stane
     u njega, tako da ima mjesta za nul-znak na kraju stringa.
     Eventualni visak znakova u redu se PRESKACE (cita i NE sprema),
     do ukljucivo \n (kraja reda). */

  /* Citanje reda funkcijom getchar (znak-po-znak).
  */

int main(void)
{
        /* U polje s stane najvise 19 znakova sadrzaja stringa, tako da IZA
           sadrzaja ima jos jedno mjesto za nul-znak (\0) = kraj stringa. */
    char s[20];
        /* Duljina ucitanog stringa (strlen), bez nul-znaka. */
    unsigned int d;
        /* Znak kod citanja. */
    char c;
        /* Indeks znaka kod citanja. */
    int i;

    printf("Upisite string u jednom redu:\n");

        /* Citanje jednog reda ulaza u string.
           Cita se cijeli red ulaza, zajedno s (prvim) krajem reda \n.
           U string se sprema najvise prvih 19 = sizeof(s) - 1
           ucitanih znakova (bez \n), a iza toga se dodaje nul-znak. */

        /* Citanje znakova koji stanu u string - najvise 19 = sizeof(s) - 1
           znakova, ali najdalje do kraja reda. Ako se ucita kraj reda
           onda ga NE spremamo u string, samo prekidamo petlju.
           Iza spremljenih znakova dodajemo nul-znak (za kraj stringa). */
    i = 0;
    while (i < 19 && (c = getchar()) != '\n')
        s[i++] = c;
    s[i] = '\0';

        /* Preskakanje znakova koji ne stanu string (ako ih ima).
           Prvo testiramo zadnji ucitani znak c. Ako nije \n, onda
           citamo znakove s ulaza, sve do ukljucivo \n.
           Ucitane znakove ne treba spremati u c. */
    if (c != '\n')
        while (getchar() != '\n');

        /* Duljina stringa. */
    d = strlen(s);

        /* Ispis ucitanog stringa i duljine (strlen). */
    printf("\nUcitani string (pocinje u sljedecem redu):\n%s\n", s);
    printf("\nDuljina stringa = %u\n", d);


        /* Provjera: nastavak citanja po istom principu = citamo
           sljedeci red u string s. */

    printf("\nUpisite sljedeci string u jednom redu:\n");

    i = 0;
    while (i < 19 && (c = getchar()) != '\n')
        s[i++] = c;
    s[i] = '\0';
    if (c != '\n')
        while (getchar() != '\n');

        /* Duljina stringa. */
    d = strlen(s);

        /* Ispis sljedeceg ucitanog stringa i duljine (strlen). */
    printf("\nDrugi string (pocinje u sljedecem redu):\n%s\n", s);
    printf("\nDuljina stringa = %u\n", d);

    return 0;
}
