#include <stdio.h>
#include <string.h>

  /* Citanje ulaza po nacelu "jedan red = jedan string".

     Treba ucitati jedan red teksta s ulaza, ukljucivo i kraj reda
     (odnosno, prijelaz u novi red), tj. zadnji procitani znak mora
     biti \n (kraj reda). U zadani string treba spremiti samo znakove
     ISPRED kraja reda, BEZ kraja reda. Dakle, kraj reda treba UCITATI,
     ali NE i spremiti (kao u gets)!

     Ulazni red moze biti PREDUGACAK.
     PAZI na "prepunjenje" stringa (broj spremljenih znakova).

     U zadani string sprema se najvise onoliko znakova koliko stane
     u njega, tako da ima mjesta za nul-znak na kraju stringa.
     Eventualni visak znakova u redu se PRESKACE (cita i NE sprema),
     do ukljucivo \n (kraja reda). */

  /* Citanje reda funkcijom scanf (formatirano) - skracena varijanta:
       Dva poziva - prvi cita string i visak, a drugi cita \n na kraju.
     Ovo, takodjer, radi DOBRO!
  */

int main(void)
{
        /* U polje s stane najvise 19 znakova sadrzaja stringa, tako da IZA
           sadrzaja ima jos jedno mjesto za nul-znak (\0) = kraj stringa. */
    char s[20];
        /* Duljina ucitanog stringa (strlen), bez nul-znaka. */
    unsigned int d;

    printf("Upisite string u jednom redu:\n");

        /* Citanje jednog reda ulaza u string.
           Cita se cijeli red ulaza, zajedno s (prvim) krajem reda \n.
           Provjerava je li nesto ucitano u string. Ako NIJE,
           postavlja s[0] = '\0', tj. s = "" (prazan string). */

        /* Maksimalna sirina polja = 19 = sizeof(s) - 1 je NUZNA. */

        /* Prvi scanf, s dvije konverzije u formatu (string + visak).
           Prvi dio formata "%19[^\n]" cita najvise 19 znakova razlicitih
           od kraja linije i sprema ih u polje s.
           Na kraju, dodaje nul-znak \0 IZA zadnjeg ucitanog znaka u s,
           tako da je s korektan string.
           Drugi dio formata "%*[^\n]" cita visak = sve znakove ispred
           kraja reda i preskace ih (NE dodjeljuje ih nekom argumentu).
           Ako je string NEPRAZAN, nije bitno je li visak prazan ili ne.
           Nakon scanf, prvi sljedeci znak na ulazu mora biti \n. */
    if (scanf("%19[^\n]%*[^\n]", s) < 1) s[0] = '\0';

        /* Drugi scanf ima format "%*c". Ucitava TOCNO jedan znak (mora
           biti \n) i preskace ga (NE dodjeljuje ga nekom argumentu). */
    scanf("%*c");    /* Ekvivalentno s getchar(); */

        /* Duljina stringa. */
    d = strlen(s);

        /* Ispis ucitanog stringa i duljine (strlen). */
    printf("\nUcitani string (pocinje u sljedecem redu):\n%s\n", s);
    printf("\nDuljina stringa = %u\n", d);


        /* Provjera: nastavak citanja po istom principu = citamo
           sljedeci red u string s. */

    printf("\nUpisite sljedeci string u jednom redu:\n");

    if (scanf("%19[^\n]%*[^\n]", s) < 1) s[0] = '\0';
    scanf("%*c");

        /* Duljina stringa. */
    d = strlen(s);

        /* Ispis sljedeceg ucitanog stringa i duljine (strlen). */
    printf("\nDrugi string (pocinje u sljedecem redu):\n%s\n", s);
    printf("\nDuljina stringa = %u\n", d);

    return 0;
}
