#include <stdio.h>

  /* Razne implementacije funkcije strcpy.
     Ovdje je vrijednost funkcije tipa void (ne vraca nista),
     a pravi strcpy vraca vrijednost tipa char *
     (pokazivac na pocetak novog = prvog stringa). */

  /* Napomena: ako neku funkciju nazovemo strcpy,
     linker javlja gresku (vec postoji u C biblioteci). */


    /* Varijanta s indeksima. */

void strcpy_1(char *s, char *t)
{
    int i = 0;

    while ((s[i] = t[i]) != '\0') ++i;

    return;
}

    /* Varijanta s pokazivacima, inkrementira pokazivace unutar petlje. */

void strcpy_2(char *s, char *t)
{
    while ((*s = *t) != '\0') {
        ++s; ++t;
    }

    return;
}

    /* Varijanta s pokazivacima, inkrementira pokazivace u uvjetu. */

void strcpy_3(char *s, char *t)
{
    while ((*s++ = *t++) != '\0');

    return;
}

    /* Skracena varijanta s pokazivacima, inkrementira pokazivace u uvjetu
       i interpretira '\0' kao laz. */

void strcpy_4(char *s, char *t)
{
    while (*s++ = *t++);

    return;
}

    /* Glavni program - testira sve varijante funkcije. */

int main(void)
{
    char stari[80] = "Programiranje 2", novi[80];

    printf(" Stari string:\n");
    printf("  stari = \"%s\"\n", stari);

    printf("\n");

    strcpy_1(novi, stari);
    printf("  strcpy_1 = \"%s\"\n", novi);
    strcpy_2(novi, stari);
    printf("  strcpy_2 = \"%s\"\n", novi);
    strcpy_3(novi, stari);
    printf("  strcpy_3 = \"%s\"\n", novi);
    strcpy_4(novi, stari);
    printf("  strcpy_4 = \"%s\"\n", novi);

    return 0;
}
