#include <stdio.h>
#include <stdlib.h>

  /* Sortiranje dinamicki alociranog polja vektora.
     Svi vektori imaju istu duljinu n.
     Polje p sadrzi pokazivace na vektore.
     Quicksort algoritam sa zamjenama vektora. */

    /* Usporedba dva vektora duljine n. */

int comp(int *a, int *b, int n)
{
    int i;
/*
    for (i = 0; i < n && a[i] == b[i]; i++);
    if (i == n) return 0;
    return a[i] - b[i];
*/
    for (i = 0; i < n; ++i)
        if (a[i] != b[i]) return a[i] - b[i];

    return 0;
}

    /* Zamjena dva vektora duljine n. */

void swap(int *a, int *b, int n)
{
    int t, i;

    for (i = 0; i < n; ++i) {
        t = a[i];
        a[i] = b[i];
        b[i] = t;
    }

    return;
}

    /* Quicksort algoritam za sortiranje polja vektora
       (svaki vektor je duljine n).
       Koristi zamjene vektora u polju (sadrzaji u p). */

void quick_sort(int *p[], int l, int d, int n)
{
    int i, j;

    if (l < d) {
        i = l + 1;
        j = d;

        while (i <= j) {
            while (i <= d && comp(p[i], p[l], n) <= 0) ++i;
            while (comp(p[j], p[l], n) > 0) --j;
            if (i < j) swap(p[i], p[j], n);
        }
        if (l < j) swap(p[j], p[l], n);
        quick_sort(p, l, j - 1, n);
        quick_sort(p, j + 1, d, n);
    }

    return;
}

    /* Glavni program. */

int main(void)
{
        /* Polje pokazivaca na vektore. */
    int **p;
        /* Pomocni pokazivac na jedan vektor. */
    int *v;
        /* Broj vektora, duljina vektora i dva indeksa. */
    int m, n, i, j;

        /* Ucitaj broj vektora i duljinu vektora. */
    printf ("Unesite broj vektora: ");
    scanf ("%d", &m);
    printf ("Unesite broj komponenti vektora: ");
    scanf ("%d", &n);

        /* Alokacija polja pokazivaca na vektore. */
    p = (int **) malloc(m * sizeof(int *));
    if (p == NULL) {
        printf ("Greska u alokaciji memorije!\n");
        exit(1);
    }
        /* Alokacija i citanje svih vektora. */
    for (i = 0; i < m ; ++i) {

            /* Alokacija i-tog vektora v = p[i]. */
        v = (int *) malloc(n * sizeof(int));
        if (v == NULL) {
            printf ("Greska u alokaciji memorije!\n");
            exit(1);
        }

            /* Citanje i-tog vektora v = p[i]. */
        for (j = 0; j < n ; ++j) {
             printf ("vektor[%d], komponenta[%d] = ", i + 1 , j + 1);
             scanf ("%d", &v[j]);
        }

            /* Spremi pokazivac v na mjesto p[i]. */
        p[i] = v;
    }

        /* Sortiranje polja vektora. */
    quick_sort(p, 0, m - 1, n);

        /* Ispis sortiranog polja. */
    printf ("\nSortirani vektori:\n");
    for (i = 0; i < m ; ++i) {
        for (j = 0; j < n ; ++j)
            printf (" %d ", p[i][j]);
        printf ("\n");
    }

        /* Dealokacija: prvo svakog vektora, onda polja p. */
    for (i = 0; i < m ; ++i)
        free(p[i]);
    free(p);

    return 0;
}
