#include <stdio.h>

  /* Spremanje uzastopnog polja bitova - Primjer 2 (bf_5).
     Neimenovani clan duljine 0 => idi u novu rijec.
     Ispis cijele strukture bit-po-bit. */

    /* Tip za uzastopna polja bitova s dvije rijeci. */

typedef struct {
    unsigned int a : 5;
    unsigned int b : 5;
    unsigned int   : 0;    /* Idi u novu rijec. */
    unsigned int c : 5;
} polje_bitova;

    /* Tip unije za prikaz polja bitova. */
    /* Ovdje koristimo da je rijec = 4 bytea = 32 bita,
       tj. sizeof(polje_bitova) = 8 = 2 * sizeof(unsigned). */

typedef union {
    polje_bitova pb;       /* 8 byteova = 64 bita. */
    unsigned int ui[2];    /* 2 rijeci od po 4 bytea. */
} PB_bits;

    /* Funkcija za ispis jedne rijeci (4 bytea = 32 bita)
       interpretirane kao unsigned int, bit-po-bit. */

void ispis_rijeci(unsigned int broj)
{
    unsigned int nbits, mask, bit, i;

        /* Broj bitova u tipu unsigned int. */
    nbits = 8 * sizeof(unsigned int);

        /* Pocetna maska ima bit 1
           na najznacajnijem mjestu. */
    mask = 0x1u << nbits - 1;

    for (i = 1; i <= nbits; ++i) {
            /* Maskiranje odgovarajuceg bita. */
        bit = broj & mask ? 1u : 0u;
            /* Ispis i blank nakon svaka 4 bita,
               osim zadnjeg. */
        printf("%u", bit);
        if (i % 4 == 0 && i < nbits) printf(" ");
            /* Pomak maske za 1 bit udesno. */
        mask >>= 1;
    }
    printf("\n");

    return;
}

void prikaz_PB(polje_bitova pb)
{
    PB_bits u;

    u.pb = pb;

    printf("   1. rijec: ");
    ispis_rijeci(u.ui[0]);
    printf("   2. rijec: ");
    ispis_rijeci(u.ui[1]);

    return;
}

    /* Glavni program za demo. */

int main(void)
{
        /* Napomena: Inicijalizacijska vrijednost za p.c
           (duljine 5 bitova) je namjerno napisana kao -1.
           U prikazu brojeva s 5 bitova dobivamo
             p.c = -1 = 31u = (11111)_2. */
    polje_bitova p = {1, 2, -1};

        /* Kod ispisa, vrijednosti clanova (polja)
           se pretvaraju u int, BEZ obzira na to
           sto su deklarirane kao unsigned int. */
    printf(" Vrijednosti pojedinih polja bitova:\n");
    printf("   p.a = %d, p.b = %d, p.c = %d\n",
           p.a, p.b, p.c);

    printf(" sizeof(p) = %u\n", sizeof(p));
    printf("\n");

    printf(" Prikaz rijeci po bitovima (31->0):\n");
    prikaz_PB(p);

    return 0;
}
