  /* Datoteka zaglavlja compl.h:
     - definira tip complex za kompleksne brojeve,
     - deklarira funkcije za operacije s kompleksnim brojevima.
     Implementacija je u datoteci compl.c.
  */

/* ======================================================================== */

    /* Tip za kompleksne brojeve. */

typedef struct {
    double re;    /* ili x */
    double im;    /* ili y */
} complex;

/* ======================================================================== */

    /* Apsolutna vrijednost kompleksnog broja. */

double zabs(complex a);   /* cabs vec postoji! */

/* ======================================================================== */

    /* Konjugiranje kompleksnog broja. */

complex conjug(complex a);

/* ======================================================================== */

    /* Zbrajanje kompleksnih brojeva. */

complex cadd(complex a, complex b);

/* ======================================================================== */

    /* Oduzimanje kompleksnih brojeva. */

complex csub(complex a, complex b);

/* ======================================================================== */

    /* Mnozenje kompleksnih brojeva. */

complex cmul(complex a, complex b);

/* ======================================================================== */

    /* Dijeljenje kompleksnih brojeva. */

complex cdiv(complex a, complex b);

/* ======================================================================== */

    /* Ispis kompleksnog broja. */

void cprint(complex a);

/* ======================================================================== */
