/* ======================================================================== */

    /* Rekurzivna funkcija za invertiranje (naopako okretanje) liste. */

    /* Rekurzivno okrece prvi element u listi i njegovu listu
       sljedbenika (ako lista sljedbenika nije prazna). Tj. polazni
       prvi element dodaje se na KRAJ invertirane liste sljedbenika.
       Rekurzija = obrada liste sljedbenika prvog elementa u listi.
       Mora paziti na
       - praznu listu (nema zadnjeg) - tada nema rekurzije,
       - jednoclanu listu (prvi = zadnji) - to je kraj rekurzije.
       Prvo okrece listu sljedbenika, a zatim prvog doda na kraj! */

lista okreni_listu_rek(lista prvi)
{
        /* Invertira poredak elemenata u listi. */

    lista p1, p2;

        /* Ako je lista prazna, invertirana lista je isto prazna.
           To se moze dogoditi samo u prvom (vanjskom) pozivu. */
    if (prvi == NULL) return NULL;

        /* U nastavku obrade, lista sigurno NIJE prazna. */

        /* Ako je lista jednoclana (prvi je zadnji), onda je invertirana
           lista jednaka polaznoj, tj. nema posla (lista sljedbenika
           prvog elementa je prazna). Tada nema rekurzije (= prekid).
           U protivnom, skrati listu za jedan (prvi) element i rekurzivno
           ponovi cijeli posao na listi sljedbenika prvog elementa.
           Na kraju, dodaj (bivseg) prvog na kraj dobivene liste. */

    if (prvi->sljed != NULL) {    /* Nije zadnji. */

            /* Lista ima bar dva elementa. Zapamti pokazivace na prvi
               i drugi element (p1 na prvi, p2 na drugi). Prvi ce
               postati zadnji u invertiranoj cijeloj listi, a drugi
               ce postati zadnji u invertiranoj listi sljedbenika. */
        p1 = prvi;
        p2 = prvi->sljed;

            /* Invertiraj listu sljedbenika prvog elementa (rekurzija).
               To vrati novi prvi = pocetak invertirane liste. */
        prvi = okreni_listu_rek(prvi->sljed);

            /* Dodaj bivseg prvog (zapamcen u p1) na kraj invertirane
               liste sljedbenika, iza bivseg drugog (zapamcen u p2). */
        p2->sljed = p1;
            /* Uzemlji novog zadnjeg (bivsi prvi, zapamcen u p1). */
        p1->sljed = NULL;
    }

    return prvi;
}

/* ======================================================================== */
