#include <stdio.h>

/****************************************************************************/

  /* Sortiranje QuickSort algoritmom.
     Prvi element x[l] je kljucni element
     i dovodimo ga na pravo mjesto u polju.
     Zamjene u kodu (bez swap). */

    /* Rekurzivna funkcija za quick_sort.
       Ocekuje bar 2 elementa, tj. l < d.
       Provjera toga mora biti PRIJE poziva. */

void quick_sort(int x[], int l, int d)
{
    int i, j, temp;

        /* Ocekuje l < d. Provjera mora prije poziva. */
    i = l + 1;
    j = d;

        /* Prolaz mora i za i == j */
    while (i <= j) {
        while (i <= d && x[i] <= x[l]) ++i;
        while (x[j] > x[l]) --j;
        if (i < j) {
            temp = x[i];
            x[i] = x[j];
            x[j] = temp;
        }
    }
    if (l < j) {
        temp = x[l];
        x[l] = x[j];
        x[j] = temp;
    }

        /* Provjera duljine prije rekurzivnih poziva. */
    if (l < j - 1)
        quick_sort(x, l, j - 1);
    if (j + 1 < d)
        quick_sort(x, j + 1, d);

    return;
}

/****************************************************************************/

int main(void)
{
    int i, n;
    int x[] = {42, 12, 55, 94, 18, 44, 67};

    n = 7;
    if (n >= 2)
        quick_sort(x, 0, n - 1);

    printf("\n Sortirano polje x:\n");
    for (i = 0; i < n; ++i) {
        printf(" x[%d] = %d\n", i, x[i]);
    }

    return 0;
}
