#include <stdio.h>

/****************************************************************************/

  /* Insertion sort algoritam (sortiranje umetanjem).
     Varijanta s 13. predavanja iz Prog1 (ins_1).
     Modificirana varijanta sa SPA (Manger, knjiga, str. 147).
     Modificirana varijanta isort3 iz knjige: Jon Bentley, Programming Pearls
       [PP2_add_web.pdf, str. 159--165.].
     Sortirani dio je spijeda. Sekvencijalno trazenje prema pocetku.
     Ako je novi element najveci, ima samo jedno nepotrebno kopiranje.

     Jednostavna modifikacija algoritma s dva kopiranja. Kopira u temp, ali
     izbjegava kopiranje natrag na isto mjesto, provjerom indeksa prije toga.
  */

/****************************************************************************/

  /* Uzlazno sortiranje (sortiranim) umetanjem.
     Sortirani dio je sprijeda.
     Ako je novi element najveci, ima samo jedno nepotrebno kopiranje
     (provjerava indeks prije drugog). */

void insertion_sort(int x[], int n)
{
    int i, j, temp;

    for (i = 1; i < n; ++i) {
        temp = x[i];
        for (j = i; j >= 1 && x[j - 1] > temp; --j)
            x[j] = x[j - 1];
        if (j < i)
            x[j] = temp;
    }

    return;
}

/****************************************************************************/

int main(void)
{
    int i, n;
    int x[] = {42, 12, 55, 94, 18, 44, 67};

    n = 7;
    insertion_sort(x, n);

    printf("\n Sortirano polje x:\n");
    for (i = 0; i < n; ++i) {
        printf(" x[%d] = %d\n", i, x[i]);
    }

    return 0;
}
