#include <stdio.h>
#include <stdlib.h>

  /* Funkcija qsort, uzlazno sortiranje polja intova.
     Primjer 2b: pazi na tipove kod poziva qsort.
       - Funkcija za usporedbu prima pokazivace korektnog tipa,
         a cast funkcije je samo u pozivu qsort. */

  /* Elegantnije rjesenje za pozive qsort, bsearch (v. KR2, str. 119--121):
     Funkcije za usporedbu su napisane u "pravim" tipovima,
     a propisni cast ide izravno u pozivu qsort, bsearch. */

    /* Funkcija usporedi ima prave tipove argumenata. */

int usporedi(const int *p_a, const int *p_b)
{
  /* Nije dobro: return *p_a - *p_b;
     jer rezultat ne mora biti korektno prikaziv! */

    if (*p_a < *p_b)
        return -1;
    else if (*p_a > *p_b)
        return 1;
    else
        return 0;
}

int main(void)
{
    int i, polje[4] = {1, 3, -4, 2};

        /* Cast na funkciju usporedi kod poziva. */

    qsort(polje, 4, sizeof(int),
          (int (*) (const void*, const void*)) usporedi);

    for (i = 0; i < 4; ++i)
        printf("%d\n", polje[i]);

    return 0;
}
